---
title: VRDisplayCapabilities
slug: Web/API/VRDisplayCapabilities
tags:
  - API
  - Experimental
  - Interface
  - Reference
  - VR
  - VRDisplayCapabilities
  - Virtual Reality
  - WebVR
---
<div>{{APIRef("WebVR API")}}{{SeeCompatTable}}</div>

<p>The <strong><code>VRDisplayCapabilities</code></strong> interface of the <a href="/en-US/docs/Web/API/WebVR_API">WebVR API</a> describes the capabilities of a {{domxref("VRDisplay")}} — its features can be used to perform VR device capability tests, for example can it return position information.</p>

<p>This interface is accessible through the {{domxref("VRDisplay.capabilities")}} property.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("VRDisplayCapabilities.canPresent")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Boolean")}} stating whether the VR display is capable of presenting content (e.g. through an HMD).</dd>
 <dt>{{domxref("VRDisplayCapabilities.hasExternalDisplay")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Boolean")}} stating whether the VR display is separate from the device's primary display.</dd>
 <dt>{{domxref("VRDisplayCapabilities.hasOrientation")}} {{deprecated_inline()}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Boolean")}} stating whether the VR display can track and return orientation information.</dd>
 <dt>{{domxref("VRDisplayCapabilities.hasPosition")}} {{readonlyInline}}</dt>
 <dd>Returns a {{domxref("Boolean")}} stating whether the VR display can track and return position information.</dd>
 <dt>{{domxref("VRDisplayCapabilities.maxLayers")}} {{readonlyInline}}</dt>
 <dd>Returns a number indicating the maximum number of {{domxref("VRLayer")}}s that the VR display can present at once (e.g. the maximum length of the array that {{domxref("VRDisplay.requestPresent()")}} can accept.)</dd>
</dl>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">function reportDisplays() {
  navigator.getVRDisplays().then(function(displays) {
    for(var i = 0; i &lt; displays.length; i++) {
      var cap = displays[i].capabilities;
      // cap is a VRDisplayCapabilities object
      var listItem = document.createElement('li');
      listItem.innerHTML = '&lt;strong&gt;Display ' + (i+1) + '&lt;/strong&gt;'
                   + '&lt;br&gt;VR Display ID: ' + displays[i].displayId
                   + '&lt;br&gt;VR Display Name: ' + displays[i].displayName
                   + '&lt;br&gt;Display can present content: ' + cap.canPresent
                   + '&lt;br&gt;Display is separate from the computer\'s main display: ' + cap.hasExternalDisplay
                   + '&lt;br&gt;Display can return position info: ' + cap.hasPosition
                   + '&lt;br&gt;Display can return orientation info: ' + cap.hasOrientation
                   + '&lt;br&gt;Display max layers: ' + cap.maxLayers;
      list.appendChild(listItem);
    }
  });
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebVR 1.1', '#interface-vrdisplaycapabilities', 'VRDisplayCapabilities')}}</td>
   <td>{{Spec2('WebVR 1.1')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.VRDisplayCapabilities")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/WebVR_API">WebVR API homepage</a></li>
 <li><a href="http://mozvr.com/">MozVr.com</a> — demos, downloads, and other resources from the Mozilla VR team.</li>
</ul>
